/*
This file is part of Slime Volley.

	Slime Volley is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Slime Volley is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Slime Volley.  If not, see <http://www.gnu.org/licenses/>.

Copyright (c) MCMic, VinDuv.

$Id: objet.h 200 2008-08-19 16:37:59Z vinduv $
*/

#ifndef _OBJET_H
#define _OBJET_H 1

#include <stdbool.h>
#include <SDL.h>

typedef struct slime_obj {
	Sint16 vx, vy; /* La vitesse */
	Uint16 w, h; /* La taille */
	float x, y; /* La position */

	Uint16 lim_bas, lim_gauche, lim_droite;

	SDL_Surface *forme;
} slime_obj;

typedef struct balle_obj {
	Sint16 vx, vy; /* La vitesse */
	float x, y; /* La position */
	float p_x, p_y; /* La position précédente */
} balle_obj;

typedef enum {
	GAUCHE,
	DROITE
} direction;

typedef enum {
	DESACTIVE = 0,
	CLAVIER = 1,
	INT_ART = 2,
	DISTANT = 3
} j_type;

typedef struct joueur {
	Sint16 vx, vy; /* La vitesse */
	float x, y; /* La position */
	float p_x, p_y; /* La position précédente */

	Uint8 taille; /* Hauteur, largeur sur deux. */

	Uint8 skin_num;
	SDL_Surface** skin_tab;
	Uint32 dern_chg_coul;

	direction sens;

	Uint16 lim_bas, lim_gauche, lim_droite;
	Uint16 oeil_x, oeil_y;

	Uint8 conf_clavier;

	bool t_haut, t_bas, t_gauche, t_droite;

	j_type type;
} joueur;

slime_obj* cree_objet(Uint16 larg_surface, Uint16 decalage_larg, Uint16 haut_surface, SDL_Surface* obj_surface);

void libere_objet(struct slime_obj* objet);
void place_objet(struct slime_obj* objet, Sint16 x, Sint16 y);

void dessin(slime_obj* objet, SDL_Surface* affichage);

void deplace_joueur(Uint8 id, const Uint16 dt);
void deplace_balle(Uint8 id, const Uint16 dt);

Sint16 dst_x(struct slime_obj* objet1, struct slime_obj* objet2);

Sint16 dst_y(struct slime_obj* objet1, struct slime_obj* objet2);

void dessine(struct slime_obj* objet, SDL_Surface* surface);

SDL_Surface* echelle_surface(SDL_Surface* orig, float ratio);
SDL_Surface** reduire_skins(SDL_Surface** grand_skin, Uint8 img_max, float ratio); /* change la taille des skin */
#endif
